#include "Xbp.ch"
#include "dll.ch"

#define GWL_EXSTYLE -20
#define WS_EX_LAYERED 0x80000
#define LWA_ALPHA 0x2

#xtranslate SetDefault(<var>, <def>) => iif(<var>==NIL, <var>:=<def>, <var>)

DLLFUNCTION GetWindowLongA( hWnd, nIndex ) USING STDCALL FROM USER32.DLL
DLLFUNCTION SetWindowLongA( hWnd, nIndex, dwNewLong ) USING STDCALL FROM USER32.DLL
DLLFUNCTION SetLayeredWindowAttributes( hWnd, crKey, bAlpha, dwFlags ) USING STDCALL FROM USER32.DLL

FUNCTION SetWindowLayered(hWnd,lActive)
LOCAL lExStyle := GetWindowLongA(hWnd, GWL_EXSTYLE)
SetDefault(lActive,.T.)
IF lActive
    IF !(lExStyle $ WS_EX_LAYERED)
        lExStyle := lExStyle + WS_EX_LAYERED
        SetWindowLongA(hWnd, GWL_EXSTYLE, lExStyle)
    ENDIF
ELSE
    IF (lExStyle $ WS_EX_LAYERED)
        lExStyle := lExStyle - WS_EX_LAYERED
        SetWindowLongA(hWnd, GWL_EXSTYLE, lExStyle)
    ENDIF
ENDIF
RETURN(NIL)

FUNCTION SetWindowTransparency(hWnd,nPercent,nToPercent,nSpeed)
LOCAL nTransparentValue
LOCAL nIx,nStep
SetDefault(nPercent,50)
SetDefault(nToPercent,nPercent)
SetDefault(nSpeed,1)
   IIF(nToPercent < nPercent, nStep := -1*nSpeed, nStep := 1*nSpeed )
   FOR nIx = nPercent TO nToPercent STEP nStep
      nTransparentValue := (1 - nIx / 100) * 255
      SetLayeredWindowAttributes(hWnd, 0, nTransparentValue, LWA_ALPHA)
   NEXT nIx
   nTransparentValue := (1 - nToPercent / 100) * 255
   SetLayeredWindowAttributes(hWnd, 0, nTransparentValue, LWA_ALPHA)
RETURN(NIL)

FUNCTION         CENTERPOS( aSize, aRefSize)
RETURN ( { Int( (aRefSize[1] - aSize[1]) / 2 ) ;
         , Int( (aRefSize[2] - aSize[2]) / 2 ) } )

PROCEDURE MenuTPZ(hWnd,oDlg,aPos)
LOCAL oSubMenu

   oSubMenu       := XbpMenu():new( oDlg  )
   oSubMenu:title := "~Transparents"
   oSubMenu:create()

   oSubMenu:addItem( { " ~90 %", {|| SetTPZ( hWnd,90 ) } ,, } )
   oSubMenu:addItem( { " ~80 %", {|| SetTPZ( hWnd,80 ) } ,, } )
   oSubMenu:addItem( { " ~70 %", {|| SetTPZ( hWnd,70 ) } ,, } )
   oSubMenu:addItem( { " ~60 %", {|| SetTPZ( hWnd,60 ) } ,, } )
   oSubMenu:addItem( { " ~50 %", {|| SetTPZ( hWnd,50 ) } ,, } )
   oSubMenu:addItem( { " ~40 %", {|| SetTPZ( hWnd,40 ) } ,, } )
   oSubMenu:addItem( { " ~30 %", {|| SetTPZ( hWnd,30 ) } ,, } )
   oSubMenu:addItem( { " ~20 %", {|| SetTPZ( hWnd,20 ) } ,, } )
   oSubMenu:addItem( { " ~10 %", {|| SetTPZ( hWnd,10 ) } ,, } )
   oSubMenu:addItem( { "  ~0 %", {|| SetTPZ( hWnd, 0 ) } ,, } )

   oSubMenu:PopUp( oDlg, aPos, 2 , ;
           XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN  )

RETURN

PROCEDURE SetTPZ(hWnd,nValue)
   SetWindowTransparency(hWnd,100,nValue,10) // sichtbar machen
RETURN

*Aufrufkonventionen:
*
*Code:
* SetWindowLayered(hWnd,.T.)         // Stil setzen
* SetWindowTransparency(hWnd,100)    // unsichtbar machen
* oDlg:Show()                        // Fenster anzeigen
* SetWindowTransparency(hWnd,100,0)  // sichtbar machen
*



