#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "OS.ch"

***********************************************
procedure appsys
return
***********************************************
PROCEDURE Main
LOCAL oDlg, oXbp, drawingArea, oPS
LOCAL nEvent, mp1, mp2
LOCAL lIsW98Run
LOCAL hWnd     := 0
LOCAL aPos     := {10,50}
LOCAL aSize    := {AppDesktop():currentSize()[1]-100,62}
LOCAL aNewPos  := {0,0}
LOCAL cText
LOCAL i

   IF Os(OS_FAMILY) == "WIN9X"
      lIsW98Run  := .T.                         // W98 is running
   ELSE
      lIsW98Run  := .F.                         // XP is running
   ENDIF

   IF IsThemeActive(.F.) == .T.
      aSize[2] := aSize[2]+15
   ENDIF
*   aPos  := CenterPos( aSize, AppDesktop():currentSize() )

   oDlg := XbpDialog():new( AppDesktop(), , aPos, aSize, , .F.)
   oDlg:taskList := .T.
   oDlg:title := "Horizontal Ruler"
   oDlg:maxButton := .F.
   oDlg:minButton := .T.
   oDlg:icon      :=100
   oDlg:drawingArea:rbClick  := {|aPos, uNIL, obj| MenuTPZ(hWnd,oDlg,aPos) }
   oDlg:create()

   hWnd := oDlg:getHWND()

   drawingArea := oDlg:drawingArea
   drawingArea:setColorBG( GRA_CLR_PALEGRAY   )
   drawingArea:setFontCompoundName( "8.Arial" )

   aNewPos[2] := 20
   FOR i := 1 TO aSize[1] STEP 100
      IF i = 1
         aNewPos[1]  := 0
         cText       := "0"
      ELSE
         aNewPos[1]  := i -12
         cText       := LTRIM(STR(i-1))
      ENDIF

      oXbp := XbpStatic():new( drawingArea, , aNewPos, {30,12}, { { XBP_PP_COMPOUNDNAME, "8.MS Sans Serif" } } )
      oXbp:caption := cText
      oXbp:clipSiblings := .T.
      oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_LEFT
      oXbp:create()
   NEXT

   oPS  := XbpPresSpace():new()
   oPS:create( oDlg:drawingArea:winDevice() )

   oDlg:drawingArea:paint := {|| DrawGraphic( oPS, aSize ) }

   IF lIsW98Run
      oDlg:show()
   ELSE
      SetWindowLayered(hWnd,.T.)        // Stil setzen
      SetWindowTransparency(hWnd,100)   // unsichtbar machen
      oDlg:show()
      SetWindowTransparency(hWnd,100,15) // sichtbar machen
   ENDIF

   SetAppFocus( oDlg )
   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
RETURN

PROCEDURE DrawGraphic( oPS, aSize  )
LOCAL aAttr[ GRA_AA_COUNT], i

   aAttr[GRA_AA_COLOR] := GRA_CLR_BLACK
   GraSetAttrLine(oPS, aAttr)
   for i = 0 to aSize[1] step 10
      graline( oPs, {i, 0}, {i, if(i % 100 = 0, 20, if(i % 50 = 0, 16, 12))})
   next
   aAttr[GRA_AL_COLOR] :=  GRA_CLR_BLUE
   GraSetAttrLine(oPS, aAttr)
   for i = 5 to aSize[1]-5 step 10
      graline( oPs, {i, 0}, {i, 8})
   next
RETURN

*
* eof
*
