#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "OS.ch"

***********************************************
PROCEDURE appsys
return
***********************************************
PROCEDURE Main
LOCAL oDlg, oXbp, drawingArea, oPS
LOCAL nEvent, mp1, mp2
LOCAL lIsW98Run
LOCAL hWnd  := 0
LOCAL aPos  := {10,50}
LOCAL aSize := {110, AppDesktop():currentSize()[2]-100}
LOCAL aNewPos := {0,0}
LOCAL cText
LOCAL i

   IF Os(OS_FAMILY) == "WIN9X"
      lIsW98Run  := .T.                         // W98 is running
   ELSE
      lIsW98Run  := .F.                         // XP is running
   ENDIF

*   IF IsThemeActive(.F.) == .T.
*      aSize := {aSize[2]+15}
*   ENDIF
*   aPos  := CenterPos( aSize, AppDesktop():currentSize() )

   oDlg := XbpDialog():new( AppDesktop(), , aPos , aSize , , .F.)
   oDlg:taskList := .t.
   oDlg:title := "Vert Ruler"
   oDlg:maxButton := .F.
   oDlg:minButton := .T.
   oDlg:icon      := 100
   oDlg:drawingArea:rbClick  := {|aPos, uNIL, obj| MenuTPZ(hWnd,oDlg,aPos) }
   oDlg:create()

   hWnd := oDlg:getHWND()

   drawingArea := oDlg:drawingArea
   drawingArea:setColorBG( GRA_CLR_PALEGRAY   )
   drawingArea:setFontCompoundName( "8.Arial" )

   aNewPos[1] := 40
   FOR i := 1 TO aSize[2] STEP 100
      IF i = 1
         aNewPos[2]  := 0
         cText       := "0"
      ELSE
         aNewPos[2]  := i - 8
         cText       := LTRIM(STR(i-1))
      ENDIF

      oXbp := XbpStatic():new( drawingArea, , aNewPos, {30,12}, { { XBP_PP_COMPOUNDNAME, "8.MS Sans Serif" } } )
      oXbp:caption := cText
      oXbp:clipSiblings := .T.
      oXbp:options := XBPSTATIC_TEXT_BOTTOM+XBPSTATIC_TEXT_CENTER
      oXbp:create()
   NEXT

   oPS  := XbpPresSpace():new()
   oPS:create( oDlg:drawingArea:winDevice() )

   oDlg:drawingArea:paint := {|| DrawGraphic( oPS, aSize ) }

   IF lIsW98Run
      oDlg:show()
   ELSE
      SetWindowLayered(hWnd,.T.)        // Stil setzen
      SetWindowTransparency(hWnd,100)   // unsichtbar machen
      oDlg:show()
      SetWindowTransparency(hWnd,100,15) // sichtbar machen
   ENDIF

   SetAppFocus( oDlg )
   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

PROCEDURE DrawGraphic( oPS, aSize  )
   local aAttr[ GRA_AA_COUNT], i

   aAttr[GRA_AA_COLOR] := GRA_CLR_BLACK
   GraSetAttrLine(oPS, aAttr)
   for i = 0 to aSize[2]  step 10
      graline( oPs, {0, i}, {if(i % 100 = 0, 30, if(i % 50 = 0, 21, 12)), i})
      graline( oPs, {if(i % 100 = 0, 73, if(i % 50 = 0, 82, 91)), i}, {110, i})
   next
   aAttr[GRA_AL_COLOR] :=  GRA_CLR_BLUE
   GraSetAttrLine(oPS, aAttr)
   for i = 5 to aSize[2]-5 step 10
      graline( oPs, {0, i}, {8, i})
      graline( oPs, {95, i}, {110, i})
   next
RETURN

*
* eof
*